/********************************************************************
 * Copyright (C) 2003 ATMEL Corporation
 *
 * ̧       :  EEPROM.C
 * ߲     :  IAR EWAVR 2.28A
 * ύX       :  2003N228
 *
 * XV
 *   1.2     2003N228   JLL
 *   0.91    2003N220   TC
 *   0.9     2003N115   TC
 *
 ********************************************************************/

#include "defines.h"
#include "eeprom.h"

static unsigned int  aBuffer [BUFFER_SIZE] =  // EEPROMڽ ޯ̧ϐ`
  {0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
  0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF};   
static unsigned char dBuffer [BUFFER_SIZE];   // EEPROMް ޯ̧ϐ`
static unsigned char bCount = 0;              // EEPROMޯ̧gpʒuo^ϐ`
static unsigned char rSleep = 0;              // ذߓʒlۑϐ`

unsigned char EEPROM_GetChar (unsigned int address)
{
  unsigned char bIndex = 0;             // Ɨpޯ̧ʒu/ϐ
  unsigned char temp,temp2;             // Ɨpꎞϐ(temp=߂l)
  do
  {
    __disable_interrupt();              // ƒɑޯ̧XV邽߂̑S荞݋֎~
    if (aBuffer[bIndex] == address)     // wڽޯ̧݌
    {                                   // (Ȃ)
      temp = dBuffer[bIndex];           // Ήްl擾
      __enable_interrupt();             // S荞ݍċ
      return (temp);                    // ޯ̧ްƋmain()֕A
    }
    else bIndex++;                      // (ȂAƗpʒuvis)
    __enable_interrupt();               // S荞ݍċ
  } while (bIndex < bCount);            // Sޯ̧e܂Ōp

  temp2 = EECR & (1<<EERIE);            // EEPROM荞݋(EERIE)ޯĒlꎞۑ
  EECR &= ~(1<<EERIE);                  // ǂݍ݂̂߂EEPROM荞݈ꎞ֎~
  
  while ( EECR & (1 << EEWE));          // OEEPROM݊܂őҋ@
  EEAR = address;                       // EEPROMڽw
  EECR |= (1 << EERE);                  // EEPROMǂݍ݊Jn
  EEAR |= 0x0000;                       // EEPROMڽ(s̱ڽŒ艻̂)
  temp = EEDR;                          // ΉEEPROMްl擾
  
  EECR |= temp2;                        // EEPROM荞݋(EERIE)ޯĉ
  
  return (temp);                        // EEPROMްlƋmain()֕A
}


void EEPROM_PutChar (unsigned int address, unsigned char data)
{
  unsigned char bIndex = 0;             // Ɨpޯ̧ʒu/ϐ

  __disable_interrupt();                // S荞݋֎~

  do
  {
    if (aBuffer[bIndex] == address)     // wڽޯ̧݌
    {                                   // (Ȃ)
      dBuffer[bIndex] = data;           // ޯ̧ްlXV
      __enable_interrupt();             // S荞ݍċ
      return;                           // main()֕A
    }
    else bIndex++;                      // (ȂAƗpʒuvis)
  } while (bIndex < bCount);            // Sޯ̧e܂Ōp

  while ( !(bCount < BUFFER_SIZE) )     // ޯ̧󂫗L܂
    __enable_interrupt();               // S荞݋őҋ@

  __disable_interrupt();                // S荞݋֎~
  aBuffer[bCount] = address;            // wڽEEPROMڽ ޯ̧ɕۑ
  dBuffer[bCount] = data;               // wްEEPROMް ޯ̧ɕۑ
  bCount++;                             // ޯ̧vis

  if ( MCUCR & (1 << SM1) )             // (ق܂A/DϊɲޒጸȊOŁA)
  {
    rSleep = ( MCUCR & ( (1<<SM2)|(1<<SM1)|(1<<SM0) ) );   // ݂̽ذߓʒlꎞۑ
    MCUCR &= ~( (1<<SM2)|(1<<SM1)|(1 << SM0) );    //  ذߓɐݒύX
                                                   // A/Dϊɲޒጸ삪gpł܂A
                                                   // ̓ŋ֎~Ӌ@\gpĂȂ
                                                   // ƂKvłB
  }

  EECR |= (1 << EERIE);                 // EEPROM荞݋
  __enable_interrupt();                 // S荞݋
  return;                               // main()֕A
}


#pragma vector = EE_RDY_vect
__interrupt void EE_RDY_ISR (void)
{
  if ( SPMCR & (1 << SPMEN) )           // ۸ݸމғ?
    return;                             // ғȂAmain()֕A

  EEAR = aBuffer[bCount - 1];           // EEPROMڽޯ̧w
  EEDR = dBuffer[bCount - 1];           // EEPROMްޯ̧w
  EECR |= (1 << EEMWE);                 // Ͻ݋
  EECR |= (1 << EEWE);                  // ݊Jn

  aBuffer[bCount - 1] = 0xFFFF;         // EEPROMڽ ޯ̧Ήʒul
  dBuffer[bCount - 1] = 0xFF;           // EEPROMް ޯ̧Ήʒul
  bCount--;                             // EEPROMޯ̧v팸

  if (bCount == 0)                      // (EEPROMޯ̧ŜȂA)
  {
    EECR  &= ~(1 << EERIE);             // EEPROM荞݋֎~
    MCUCR &= ~( (1<<SM2)|(1<<SM1)|(1<<SM0) );  // ذߓIޯĈꎞ
    MCUCR |= rSleep;                    // ذߓʉ
  }
}
